<?php
/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/
class MEMBERSHIP_CLASS_DeleteMembershipForm extends Form
{
    public function __construct( )
    {
        parent::__construct('delete-membership-form');

        $this->setAjaxResetOnSuccess(false);

        $this->setAjax(true);
        $this->setAction(OW::getRouter()->urlForRoute('membership_delete_type'));

        $lang = OW::getLanguage();

        $typeId = new HiddenField('typeId');
        $typeId->setRequired(true);
        $this->addElement($typeId);

        $newTypeId = new Selectbox('newTypeId');
        $newTypeId->setHasInvitation(false);
        $this->addElement($newTypeId);

        $types = new RadioGroupItemField('type');
        $types->setRequired(true);
        $types->setLabel($lang->text('membership', 'set_membership'));
        $this->addElement($types);

        $this->bindJsFunction(
            Form::BIND_SUCCESS,
            "function( data ) {
                if ( data.result ) {
                    document.location.reload();
                }
            }"
        );

        $script = '$("#btn-confirm-type-delete").click(function(){
            if ( confirm('.json_encode($lang->text('membership', 'type_delete_confirm')).') ) {
                 $(this).parents("form:eq(0)").submit();
            }
        });
        ';

        OW::getDocument()->addOnloadScript($script);
    }
}