<?php
/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/
class MEMBERSHIP_CMP_EditMembership extends OW_Component
{
    /**
     * Class constructor
     */
    public function __construct( $typeId )
    {
        parent::__construct();

        if ( !OW::getUser()->isAdmin() )
        {
            $this->setVisible(false);

            return;
        }

        $service = MEMBERSHIP_BOL_MembershipService::getInstance();

        $type = $service->findTypeById($typeId);

        $plans = $service->getPlanList($typeId);
        $this->assign('plans', $plans);
        $this->assign('membership', $service->getMembershipTitle($type->roleId));
        $this->assign('typeId', $typeId);
        $this->assign('currency', BOL_BillingService::getInstance()->getActiveCurrency());

        $script =
        '$("#btn_add_plan").click(function(){
            $(".paid-plan-template:first").clone().insertBefore($(this).closest("tr")).show();
        });

        $("#btn_add_trial_plan").click(function(){
            $(".trial-plan-template:first").clone().insertBefore($(this).closest("tr")).show();
        });

        $("#plans-form").submit(function(){
            $(".paid-plan-template:first").remove();
            $(".trial-plan-template:first").remove();
        });

        $("body")
            .on("change", "#check_all", function(){
                $("#plans .plan_id, #plans .new_plan_id").prop("checked", $(this).prop("checked"));
            });

        $("#btn_delete").click(function(){
            var $plans = $("#plans input.plan_id:checked");
            if ( $plans.length ) {
                var plans = $plans.map(function(){
                    return $(this).data("pid");
                }).get();
                $.ajax({
                    type: "POST",
                    url: ' . json_encode(OW::getRouter()->urlForRoute('membership_delete_plans')) . ',
                    data: { plans : plans },
                    dataType: "json",
                    success : function(data){
                        $plans.each(function(){
                            $(this).closest("tr").remove();
                        });
                    }
                });
            }
            var $newPlans = $("#plans input.new_plan_id:checked:visible");
            if ( $newPlans.length )
            {
                $newPlans.each(function(){
                    $(this).closest("tr").remove();
                });
            }
        });
        ';
        
        $this->assign('periodUnitsList', MEMBERSHIP_BOL_MembershipService::getInstance()->getPeriodUnitsList());
        
        OW::getDocument()->addOnloadScript($script);
    }
}