<?php
/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/
class PROTECTEDPHOTOS_CLASS_SelectedFriendListValidator extends OW_Validator
{
    private $formName;
    private $privacyInputName;

    public function __construct( $formName, $privacyInputName )
    {
        $this->formName = $formName;
        $this->privacyInputName = $privacyInputName;
        $this->errorMessage = OW::getLanguage()->text('protectedphotos', 'individual_friends_error');
    }

    public function isValid( $value )
    {
        if ( !empty($_POST[$this->privacyInputName]) && trim($_POST[$this->privacyInputName]) === PROTECTEDPHOTOS_BOL_Service::PRIVACY_INDIVIDUAL_FRIENDS )
        {
            return mb_strlen(trim($value)) !== 0;
        }

        return true;
    }

    public function getJsValidator()
    {
        return UTIL_JsGenerator::composeJsString('{
            validate: function( value ){
                if ( owForms[{$formName}].getElement({$privacyInputName}).getValue() === {$privacyPassword} )
                {
                    if ( value.trim().length === 0 )
                    {
                        OW.error(this.getErrorMessage());

                        throw this.getErrorMessage();
                    }
                }
            },
            getErrorMessage: function(){return {$errorMessage}}
        }', array(
            'formName' => $this->formName,
            'privacyInputName' => $this->privacyInputName,
            'privacyPassword' => PROTECTEDPHOTOS_BOL_Service::PRIVACY_INDIVIDUAL_FRIENDS,
            'errorMessage' => $this->errorMessage
        ));
    }
}
